//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGRID"
#pragma resource "*.dfm"
#include "kresl.h"
THlavniOkno *HlavniOkno;

//static TColor Barva[] = {clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clLtGray, clDkGray, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clWhite,};
const char *implicitni_nazev = "kresba.kre";

//---------------------------------------------------------------------------
__fastcall THlavniOkno::THlavniOkno(TComponent* Owner)
        : TForm(Owner), barva(clBlack), sila(1), dole(false), jmeno(implicitni_nazev)
{
}
//---------------------------------------------------------------------------
void __fastcall THlavniOkno::barvyChange(TObject *Sender)
{
  static TColor Barva[] = {clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clLtGray, clDkGray, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clWhite,};
  barva = Barva[barvy ->ForegroundIndex];
  pa_barva -> Color = barva;
}
//---------------------------------------------------------------------------
void __fastcall THlavniOkno::tl_jinaClick(TObject *Sender)
{
  if(dlg_barva -> Execute())
  {
    barva = dlg_barva -> Color;
    pa_barva -> Color = barva;
  }      
}
//---------------------------------------------------------------------------
void __fastcall THlavniOkno::posuvChange(TObject *Sender)
{
  sila = posuv -> Position;
  TCanvas *C = im_sila -> Canvas;
  C -> FillRect(Rect(0,0,im_sila -> Width, im_sila -> Height));
  C -> Pen -> Width = sila;
  C -> MoveTo(im_sila -> Width /2, 0);
  C -> LineTo(im_sila -> Width /2, im_sila -> Height);
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::FormCreate(TObject *Sender)
{
  posuvChange(Sender);
  barvyChange(Sender);
  mn_novyClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_novyClick(TObject *Sender)
{
  delete obr;
  obr = new TObraz;
  jmeno = implicitni_nazev;
//  int x = pa_obr -> Width;
//  int y = pa_obr -> Height;
  int x = im_kresba -> Width;
  int y = im_kresba -> Height;
  im_kresba -> Picture -> Bitmap -> Height = y;
  im_kresba -> Picture -> Bitmap -> Width = x;
  im_kresba -> Canvas -> FillRect(Rect(0,0,x,y));
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  dole = true;
  delete lajna;
  lajna = new TCara(barva, sila);
  lajna -> pridej(TBod(X,Y));
  im_kresba -> Canvas -> Pen -> Color = barva;
  im_kresba -> Canvas -> Pen -> Width = sila;
  im_kresba -> Canvas -> MoveTo(X,Y);
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if(dole)
  {
    lajna -> pridej(TBod(X,Y));
    im_kresba -> Canvas -> LineTo(X,Y);
  }  
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if(dole)
  {
    dole = false;
    lajna -> pridej(TBod(X,Y));
    im_kresba -> Canvas -> LineTo(X,Y);
    obr -> pridej(lajna);
  }
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_ulozClick(TObject *Sender)
{
  if(jmeno == implicitni_nazev)
    mn_ulozjakoClick(Sender);
  else
  {
    if(ExtractFileExt(jmeno)== ".kre")
      obr -> uloz(jmeno);
    else if(ExtractFileExt(jmeno)==".bmp")
      im_kresba -> Picture -> SaveToFile(jmeno);
  }    
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_ulozjakoClick(TObject *Sender)
{
  dlg_uloz -> FileName = jmeno.Delete(jmeno.LastDelimiter("."),4);
  if(dlg_uloz -> Execute())
  {
    jmeno = dlg_uloz -> FileName;
    if(FileExists(jmeno))
      if(Application -> MessageBox(("Soubor "+jmeno+" existuje.\nMm ho pepsat?").c_str(),"Upozornn",MB_YESNO|MB_ICONQUESTION)==IDNO)
        return;
    if(ExtractFileExt(jmeno)== "*.kre")
      obr -> uloz(jmeno);
    else if(ExtractFileExt(jmeno)== "*.bmp")
      im_kresba -> Picture -> SaveToFile(jmeno);
  }          
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::dlg_ulozTypeChange(TObject *Sender)
{
  static AnsiString ext[] = {"*.kre", "*.bmp"};
  dlg_uloz -> DefaultExt = ext[dlg_uloz -> FilterIndex - 1];        
}
//---------------------------------------------------------------------------

void __fastcall THlavniOkno::mn_otevriClick(TObject *Sender)
{
  if(dlg_otevri -> Execute())
  {
    AnsiString jmeno = dlg_otevri -> FileName;
    delete obr;
    obr = new TObraz;
    im_kresba -> Canvas -> FillRect(Rect(0,0,im_kresba -> Width, im_kresba -> Height));
    obr -> precti(jmeno);
    obr -> nakresli(im_kresba -> Canvas);
  }          
}
//---------------------------------------------------------------------------


